"use strict";
/*---------------------------------------------------------------------------------------------
 * Copyright (c) Bentley Systems, Incorporated. All rights reserved.
 * See LICENSE.md in the project root for license terms and full copyright notice.
 *--------------------------------------------------------------------------------------------*/
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("./ToastStyling.scss");
const React = __importStar(require("react"));
const Toast_1 = __importDefault(require("./Toast"));
class ToastMaster extends React.Component {
    constructor(props) {
        super(props);
        this.notify = this.notify.bind(this);
        this.closeAll = this.closeAll.bind(this);
        props.bindNotify(this.notify);
        props.bindCloseAll(this.closeAll);
        this.state = {
            toasts: [],
        };
        this.createToastInstance = this.createToastInstance.bind(this);
        this.removeToast = this.removeToast.bind(this);
    }
    /* Remove the specified toast from the state*/
    removeToast(id) {
        this.setState((prevState) => {
            return {
                toasts: prevState.toasts.filter((toast) => toast.id !== id),
            };
        });
    }
    /* Set isVisible to false in the specified Toast using ID*/
    closeToast(id) {
        this.setState((prevState) => {
            return {
                toasts: prevState.toasts.map((toast) => {
                    if (toast.id === id) {
                        return Object.assign(Object.assign({}, toast), { isVisible: false });
                    }
                    return toast;
                }),
            };
        });
    }
    render() {
        return (React.createElement("span", { className: "itwin-toast-wrapper" }, this.state.toasts.map((_a) => {
            var { id } = _a, props = __rest(_a, ["id"]);
            return (React.createElement(Toast_1.default, Object.assign({ key: id, onRemove: this.removeToast.bind(this, id) }, props)));
        })));
    }
    /* Return a ToastObject and add it into the state */
    notify(settings) {
        const instance = this.createToastInstance(settings);
        this.setState((prevState) => {
            return {
                toasts: [instance, ...prevState.toasts],
            };
        });
        return instance;
    }
    /* Set isVisible to false for every toast in the state*/
    closeAll() {
        this.state.toasts.forEach((toast) => {
            this.closeToast(toast.id);
        });
    }
    /* Create a ToastObject using settings passed in from Toaster */
    createToastInstance(settings) {
        const uid = ++ToastMaster.idCounter;
        return {
            category: settings.category,
            duration: settings.duration,
            hasCloseButton: settings.hasCloseButton,
            id: uid,
            isVisible: true,
            link: settings.link,
            text: settings.text,
            type: settings.type,
        };
    }
}
exports.default = ToastMaster;
ToastMaster.idCounter = 0;
//# sourceMappingURL=ToastMaster.js.map